package com.si.anddos.dpadapters;

import android.text.format.Time;



/**
 * A class representing one Download in DB
 * @author Carlos Martinez
 */
public class Download {
	private long id;
	private Time dateTime;
	private String url;
	private String fileName;
	private Account account;
	private int status;
	
	/*
	 * priority of download 
	 * 0 = low (AnddosDbAdapter.PriorityLow)
	 * 1 = normal (AnddosDbAdapter.PriorityNormal)
	 * 2 = high (AnddosDbAdapter.PriorityHigh)
	 * to check use static constants in brackets
	 */
	private int priority;
	
	
	

	public Download(){
		
	}
	
	public Download(Time dateTime, String url, String fileName, Account account){
		this.url = url;
		this.fileName = fileName;
		this.dateTime = dateTime;
		this.account = account;
	}

	public Download(Time dateTime, String url, String fileName, Account account, long id) {
		this.url = url;
		this.fileName = fileName;
		this.dateTime = dateTime;
		this.account = account;
		this.id = id;
	}
	
	public void setStatus(int status) {
		this.status = status;
	}
	
	public int getStatus() {
		return this.status;
	}
	
	public void setId(long id) {
		this.id = id;
	}


	public long getId() {
		return id;
	}

	public Time getDateTime() {
		return dateTime;
	}

	public void setDateTime(Time dateTime) {
		this.dateTime = dateTime;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getFileName() {
		return fileName;
	}

	public void setFileName(String fileName) {
		this.fileName = fileName;
	}

	public Account getAccount() {
		return account;
	}

	public void setAccount(Account account) {
		this.account = account;
	}
	
	public int getPriority() {
		return priority;
	}

	public void setPriority(int priority) {
		this.priority = priority;
	}
}
